/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.ProductoServicio;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.ProductoServicioService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Textarea;
import org.zkoss.zul.Button;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Radio;

/**
 *
 * @author Shiro
 */
@Controller("editarProductoServicioControllerMX")
@Scope("prototype")
public class EditarProductoServicioController extends MyGenericForwardComposer {

    @Autowired
    private ProductoServicioService pSerService;
    @Autowired
    private EmpresaService empresaService;
    private ProductoServicio ps;
    private MyListbox PSList;
    private MyTextbox txtNome;
    private Combobox cmbEmpresa;
    private Button btnApagar;
    private Radio rdProducto;
    private Radio rdServicio;
    private List<Empresa> lsEmpresa;
    private static Logger log = Logger.getLogger(EditarProductoServicioController.class);

    public MyListbox getPSList() {
        return PSList;
    }

    public void setPSList(MyListbox PSList) {
        this.PSList = PSList;
    }

    public ProductoServicio getPs() {
        return ps;
    }

    public void setPs(ProductoServicio ps) {
        this.ps = ps;
    }

    public ProductoServicioService getpSerService() {
        return pSerService;
    }

    public void setpSerService(ProductoServicioService pSerService) {
        this.pSerService = pSerService;
    }

    public Radio getRdProducto() {
        return rdProducto;
    }

    public void setRdProducto(Radio rdProducto) {
        this.rdProducto = rdProducto;
    }

    public Radio getRdServicio() {
        return rdServicio;
    }

    public void setRdServicio(Radio rdServicio) {
        this.rdServicio = rdServicio;
    }

    public MyTextbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(MyTextbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        lsEmpresa = empresaService.obtenerIndTipo2();

        super.doAfterCompose(comp);

        ps = (ProductoServicio) Executions.getCurrent().getArg().get("ps");
        PSList = (MyListbox) Executions.getCurrent().getArg().get("PSList");

        if (ps.getProductoservicioId() != null) {
            if (ps.getIndtipo().equals("S")) {

                rdServicio.setChecked(true);
            } else if (ps.getIndtipo().equals("P")) {

                rdProducto.setChecked(true);
            }
        } else {
            rdServicio.setChecked(true);
        }
        if (ps.getProductoservicioId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }
        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {

        txtNome.getValue();
        cmbEmpresa.getValue();

        try {

            if (rdServicio.isChecked()) {
                ps.setIndtipo("S");
            } else if (rdProducto.isChecked()) {
                ps.setIndtipo("P");
            }

            List<ProductoServicio> lsPs = pSerService.obtener(ps);
            boolean podeSalvar = false;

            if (lsPs.isEmpty()) {
                podeSalvar = true;
            } else {
                for (ProductoServicio pser : lsPs) {
                    if (pser.getProductoservicioId().equals(ps.getProductoservicioId())) {
                        podeSalvar = true;
                    } else {
                        podeSalvar = false;
                    }
                }
            }

            if (podeSalvar) {
                if (ps.getProductoservicioId() == null) {
                    pSerService.suscribir(ps);
                    PSList.addItem(ps);
                } else {
                    pSerService.actualizacion(ps);
                    PSList.updateItem(ps);
                }

                Messagebox.show(
                        Labels.getLabel("editarProductoServicioController.MSG.suscribirOK"),
                        Labels.getLabel("editarProductoServicioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();

            } else {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarProductoServicioController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);

            }

        } catch (Exception ex) {
            log.error("editarProductoServicioController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarProductoServicioController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarProductoServicioController.MSG.BorrarPergunta"),
                    Labels.getLabel("editarProductoServicioController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                pSerService.borrar(ps);

                Messagebox.show(
                        Labels.getLabel("editarProductoServicioController.MSG.BorrarOK"),
                        Labels.getLabel("editarProductoServicioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                PSList.removeItem(ps);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public Combobox getCmbEmpresa() {
        return cmbEmpresa;
    }

    public void setCmbEmpresa(Combobox cmbEmpresa) {
        this.cmbEmpresa = cmbEmpresa;
    }

    public EmpresaService getEmpresaService() {
        return empresaService;
    }

    public void setEmpresaService(EmpresaService empresaService) {
        this.empresaService = empresaService;
    }

    public List<Empresa> getLsEmpresa() {
        return lsEmpresa;
    }

    public void setLsEmpresa(List<Empresa> lsEmpresa) {
        this.lsEmpresa = lsEmpresa;
    }
}
